searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"NSQ.Config.html","title":"NSQ.Config","type":"module"},{"doc":"","ref":"NSQ.Config.html#normalize/1","title":"NSQ.Config.normalize/1","type":"function"},{"doc":"","ref":"NSQ.Config.html#normalize_hosts/1","title":"NSQ.Config.normalize_hosts/1","type":"function"},{"doc":"Given a config, tell us what's wrong with it. If nothing is wrong, we'll\nreturn `{:ok, config}`.","ref":"NSQ.Config.html#validate/1","title":"NSQ.Config.validate/1","type":"function"},{"doc":"iex> NSQ.Config.validate(%NSQ.Config{})\n    {:ok, %NSQ.Config{}}\n\n    iex> NSQ.Config.validate(%NSQ.Config{max_attempts: -1})\n    {:error, [\"max_attempts: -1 below minimum 0\"]}","ref":"NSQ.Config.html#validate/1-examples","title":"Examples - NSQ.Config.validate/1","type":"function"},{"doc":"","ref":"NSQ.ConnInfo.html","title":"NSQ.ConnInfo","type":"module"},{"doc":"Get info for all connections in a map like `%{conn_id: %{... data ...}}`.","ref":"NSQ.ConnInfo.html#all/1","title":"NSQ.ConnInfo.all/1","type":"function"},{"doc":"Given a `conn` object return by `Consumer.get_connections` or connection state object, return the\nconnection ID.","ref":"NSQ.ConnInfo.html#conn_id/1","title":"NSQ.ConnInfo.conn_id/1","type":"function"},{"doc":"Given a consumer state object and an nsqd host/port tuple, return the\nconnection ID.","ref":"NSQ.ConnInfo.html#conn_id/2","title":"NSQ.ConnInfo.conn_id/2","type":"function"},{"doc":"Delete connection info matching `conn_id`. This should be called when a\nconnection is terminated.","ref":"NSQ.ConnInfo.html#delete/2","title":"NSQ.ConnInfo.delete/2","type":"function"},{"doc":"Get info for the connection matching `conn_id`.","ref":"NSQ.ConnInfo.html#fetch/2","title":"NSQ.ConnInfo.fetch/2","type":"function"},{"doc":"Get specific data for the connection, e.g.:\n\n    [rdy_count, last_rdy] = fetch(pid, \"conn_id\", [:rdy_count, :last_rdy])\n    rdy_count = fetch(pid, \"conn_id\", :rdy_count)","ref":"NSQ.ConnInfo.html#fetch/3","title":"NSQ.ConnInfo.fetch/3","type":"function"},{"doc":"","ref":"NSQ.ConnInfo.html#init/1","title":"NSQ.ConnInfo.init/1","type":"function"},{"doc":"`func` is passed `conn_info` for each connection.","ref":"NSQ.ConnInfo.html#reduce/3","title":"NSQ.ConnInfo.reduce/3","type":"function"},{"doc":"","ref":"NSQ.ConnInfo.html#update/2","title":"NSQ.ConnInfo.update/2","type":"function"},{"doc":"Update the info for a specific connection matching `conn_id`.\nIf a function is supplied `conn_info`is passed to `func`, and the result of `func` is saved as the new `conn_info`.\nif a map is supplied, the map is merged into the existing conn_info.","ref":"NSQ.ConnInfo.html#update/3","title":"NSQ.ConnInfo.update/3","type":"function"},{"doc":"Sets up a TCP connection to NSQD. Both consumers and producers use this.","ref":"NSQ.Connection.html","title":"NSQ.Connection","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Connection.html#child_spec/1","title":"NSQ.Connection.child_spec/1","type":"function"},{"doc":"","ref":"NSQ.Connection.html#close/2","title":"NSQ.Connection.close/2","type":"function"},{"doc":"Calls the command and waits for a response. If a command shouldn't have a\nresponse, use cmd_noresponse.","ref":"NSQ.Connection.html#cmd/3","title":"NSQ.Connection.cmd/3","type":"function"},{"doc":"Calls the command but doesn't expect any response. This is important if the\nNSQ command does not in fact generate a response. If you use `cmd` and a\nresponse is sent, it will live forever in the command queue.","ref":"NSQ.Connection.html#cmd_noresponse/2","title":"NSQ.Connection.cmd_noresponse/2","type":"function"},{"doc":"","ref":"NSQ.Connection.html#get_state/1","title":"NSQ.Connection.get_state/1","type":"function"},{"doc":"","ref":"NSQ.Connection.html#init/1","title":"NSQ.Connection.init/1","type":"function"},{"doc":"","ref":"NSQ.Connection.html#start_link/1","title":"NSQ.Connection.start_link/1","type":"function"},{"doc":"A tuple with a string ID (used to target the connection in\nNSQ.Connection.Supervisor) and a PID of the connection.","ref":"NSQ.Connection.html#t:connection/0","title":"NSQ.Connection.connection/0","type":"type"},{"doc":"A tuple with a host and a port.","ref":"NSQ.Connection.html#t:host_with_port/0","title":"NSQ.Connection.host_with_port/0","type":"type"},{"doc":"A map, but we can be more specific by asserting some entries that should be\nset for a connection's state map.","ref":"NSQ.Connection.html#t:state/0","title":"NSQ.Connection.state/0","type":"type"},{"doc":"","ref":"NSQ.Connection.Buffer.html","title":"NSQ.Connection.Buffer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Connection.Buffer.html#child_spec/1","title":"NSQ.Connection.Buffer.child_spec/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#init/1","title":"NSQ.Connection.Buffer.init/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#recv/2","title":"NSQ.Connection.Buffer.recv/2","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#recv/3","title":"NSQ.Connection.Buffer.recv/3","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#recv!/2","title":"NSQ.Connection.Buffer.recv!/2","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#recv!/3","title":"NSQ.Connection.Buffer.recv!/3","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#send!/2","title":"NSQ.Connection.Buffer.send!/2","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#setup_compression/3","title":"NSQ.Connection.Buffer.setup_compression/3","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#setup_socket/3","title":"NSQ.Connection.Buffer.setup_socket/3","type":"function"},{"doc":"","ref":"NSQ.Connection.Buffer.html#start_link/2","title":"NSQ.Connection.Buffer.start_link/2","type":"function"},{"doc":"Both consumers and producers use Connection, which, at a lower level, kicks\noff message processing and issues commands to NSQD. This module handles some\nof the trickier command queueing, flushing, etc.","ref":"NSQ.Connection.Command.html","title":"NSQ.Connection.Command","type":"module"},{"doc":"","ref":"NSQ.Connection.Command.html#exec/4","title":"NSQ.Connection.Command.exec/4","type":"function"},{"doc":"","ref":"NSQ.Connection.Command.html#flush_cmd_queue/1","title":"NSQ.Connection.Command.flush_cmd_queue/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Command.html#flush_cmd_queue!/1","title":"NSQ.Connection.Command.flush_cmd_queue!/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Command.html#send_data_and_queue_resp/4","title":"NSQ.Connection.Command.send_data_and_queue_resp/4","type":"function"},{"doc":"","ref":"NSQ.Connection.Command.html#send_response_to_caller/2","title":"NSQ.Connection.Command.send_response_to_caller/2","type":"function"},{"doc":"","ref":"NSQ.Connection.Command.html#update_state_from_cmd/2","title":"NSQ.Connection.Command.update_state_from_cmd/2","type":"function"},{"doc":"","ref":"NSQ.Connection.Initializer.html","title":"NSQ.Connection.Initializer","type":"module"},{"doc":"","ref":"NSQ.Connection.Initializer.html#connect/1","title":"NSQ.Connection.Initializer.connect/1","type":"function"},{"doc":"Immediately after connecting to the NSQ socket, both consumers and producers\nfollow this protocol.","ref":"NSQ.Connection.Initializer.html#do_handshake/1","title":"NSQ.Connection.Initializer.do_handshake/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Initializer.html#do_handshake!/1","title":"NSQ.Connection.Initializer.do_handshake!/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Initializer.html#inflate/1","title":"NSQ.Connection.Initializer.inflate/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Initializer.html#ssl_versions/1","title":"NSQ.Connection.Initializer.ssl_versions/1","type":"function"},{"doc":"","ref":"NSQ.Connection.MessageHandling.html","title":"NSQ.Connection.MessageHandling","type":"module"},{"doc":"","ref":"NSQ.Connection.MessageHandling.html#handle_nsq_message/2","title":"NSQ.Connection.MessageHandling.handle_nsq_message/2","type":"function"},{"doc":"This is the recv loop that we kick off in a separate process immediately\nafter the handshake. We send each incoming NSQ message as an erlang message\nback to the connection for handling.","ref":"NSQ.Connection.MessageHandling.html#recv_nsq_messages/2","title":"NSQ.Connection.MessageHandling.recv_nsq_messages/2","type":"function"},{"doc":"","ref":"NSQ.Connection.MessageHandling.html#update_conn_stats_on_message_done/2","title":"NSQ.Connection.MessageHandling.update_conn_stats_on_message_done/2","type":"function"},{"doc":"A consumer or producer will initialize this supervisor empty to start.\nCandidate nsqd connections will be discovered elsewhere and added with\nstart_child.","ref":"NSQ.Connection.Supervisor.html","title":"NSQ.Connection.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Connection.Supervisor.html#child_spec/1","title":"NSQ.Connection.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Supervisor.html#init/1","title":"NSQ.Connection.Supervisor.init/1","type":"function"},{"doc":"","ref":"NSQ.Connection.Supervisor.html#start_child/4","title":"NSQ.Connection.Supervisor.start_child/4","type":"function"},{"doc":"","ref":"NSQ.Connection.Supervisor.html#start_link/1","title":"NSQ.Connection.Supervisor.start_link/1","type":"function"},{"doc":"A consumer is a process that creates connections to NSQD to receive messages\nfor a specific topic and channel. It has three primary functions:\n\n1. Provide a simple interface for a user to setup and configure message\n   handlers.\n2. Balance RDY across all available connections.\n3. Add/remove connections as they are discovered.","ref":"NSQ.Consumer.html","title":"NSQ.Consumer","type":"module"},{"doc":"In standard practice, the only function a user should need to know about is\n`NSQ.Consumer.Supervisor.start_link/3`. It takes a topic, a channel, and an\nNSQ.Config struct, which has possible values defined and explained in\nnsq/config.ex.\n\n    {:ok, consumer} = NSQ.Consumer.Supervisor.start_link(\"my-topic\", \"my-channel\", %NSQ.Config{\n      nsqlookupds: [\"127.0.0.1:6751\", \"127.0.0.1:6761\"],\n      message_handler: fn(body, msg) ->\n        # handle them message\n        :ok\n      end\n    })\n\n#","ref":"NSQ.Consumer.html#module-simple-interface","title":"Simple Interface - NSQ.Consumer","type":"module"},{"doc":"The return value of the message handler determines how we will respond to\nNSQ.\n\n#### :ok\n\nThe message was handled and should not be requeued. This sends a FIN command\nto NSQD.\n\n#### :req\n\nThis message should be requeued. With no delay specified, it will calculate\ndelay exponentially based on the number of attempts. Refer to\nMessage.calculate_delay for the exact formula.\n\n#### {:req, delay}\n\nThis message should be requeued. Use the delay specified. A positive integer\nis expected.\n\n#### {:req, delay, backoff}\n\nThis message should be requeued. Use the delay specified. If `backoff` is\ntruthy, the consumer will temporarily set RDY to 0 in order to stop receiving\nmessages. It will use a standard strategy to resume from backoff mode.\n\nThis type of return value is only meant for exceptional cases, such as\ninternal network partitions, where stopping message handling briefly could be\nbeneficial. Only use this return value if you know what you're doing.\n\nA message handler that throws an unhandled exception will automatically\nrequeue and enter backoff mode.\n\n#","ref":"NSQ.Consumer.html#module-message-handler-return-values","title":"Message handler return values - NSQ.Consumer","type":"module"},{"doc":"NSQ.Config has a property called msg_timeout, which configures the NSQD\nserver to wait that long before assuming the message failed and requeueing\nit. If you expect your message handler to take longer than that, you can call\n`NSQ.Message.touch(msg)` from the message handler to reset the server-side\ntimer.\n\n#","ref":"NSQ.Consumer.html#module-nsq-message-touch-msg","title":"NSQ.Message.touch(msg) - NSQ.Consumer","type":"module"},{"doc":"If you'd like to manually change the max in flight of a consumer, use this\nfunction. It will cause the consumer's connections to rebalance to the new\nvalue. If the new `max_in_flight` is smaller than the current messages in\nflight, it must wait for the existing handlers to finish or requeue before\nit can fully rebalance.","ref":"NSQ.Consumer.html#module-nsq-consumer-change_max_in_flight-consumer-max_in_flight","title":"NSQ.Consumer.change_max_in_flight(consumer, max_in_flight) - NSQ.Consumer","type":"module"},{"doc":"Public function to change `max_in_flight` for a consumer. The new value will\nbe balanced across connections.","ref":"NSQ.Consumer.html#change_max_in_flight/2","title":"NSQ.Consumer.change_max_in_flight/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Consumer.html#child_spec/1","title":"NSQ.Consumer.child_spec/1","type":"function"},{"doc":"","ref":"NSQ.Consumer.html#close/1","title":"NSQ.Consumer.close/1","type":"function"},{"doc":"","ref":"NSQ.Consumer.html#conn_info/1","title":"NSQ.Consumer.conn_info/1","type":"function"},{"doc":"If the event manager is not defined in NSQ.Config, it will be generated. So\nif you want to attach event handlers on the fly, you can use a syntax like\n`NSQ.Consumer.event_manager(consumer) |> :gen_event.add_handler(MyHandler, [])`","ref":"NSQ.Consumer.html#event_manager/1","title":"NSQ.Consumer.event_manager/1","type":"function"},{"doc":"NSQ.Consumer.Supervisor.start_link returns the supervisor pid so that we can\neffectively recover from consumer crashes. This function takes the supervisor\npid and returns the consumer pid. We use this for public facing functions so\nthat the end user can simply target the supervisor, e.g.\n`NSQ.Consumer.change_max_in_flight(supervisor_pid, 100)`. Not for external\nuse.","ref":"NSQ.Consumer.html#get/1","title":"NSQ.Consumer.get/1","type":"function"},{"doc":"Called from tests to assert correct consumer state. Not for external use.","ref":"NSQ.Consumer.html#get_state/1","title":"NSQ.Consumer.get_state/1","type":"function"},{"doc":"On init, we create a connection for each NSQD instance discovered, and set\nup loops for discovery and RDY redistribution.","ref":"NSQ.Consumer.html#init/1","title":"NSQ.Consumer.init/1","type":"function"},{"doc":"Starts a Consumer process, called via the supervisor.","ref":"NSQ.Consumer.html#start_link/1","title":"NSQ.Consumer.start_link/1","type":"function"},{"doc":"","ref":"NSQ.Consumer.html#starved?/1","title":"NSQ.Consumer.starved?/1","type":"function"},{"doc":"A tuple with a string ID (used to target the connection in\nNSQ.Connection.Supervisor) and a PID of the connection.","ref":"NSQ.Consumer.html#t:connection/0","title":"NSQ.Consumer.connection/0","type":"type"},{"doc":"A map, but we can be more specific by asserting some entries that should be\nset for a connection's state map.","ref":"NSQ.Consumer.html#t:cons_state/0","title":"NSQ.Consumer.cons_state/0","type":"type"},{"doc":"A tuple with a host and a port.","ref":"NSQ.Consumer.html#t:host_with_port/0","title":"NSQ.Consumer.host_with_port/0","type":"type"},{"doc":"","ref":"NSQ.Consumer.html#t:state/0","title":"NSQ.Consumer.state/0","type":"type"},{"doc":"When messages fail unexpectedly hard, we go into \"backoff mode\".","ref":"NSQ.Consumer.Backoff.html","title":"NSQ.Consumer.Backoff","type":"module"},{"doc":"This function is called asynchronously from `resume_later`. It\nwill cause one connection to have RDY 1. We only resume after this if\nmessages succeed a number of times == backoff_counter. (That logic is in\nstart_stop_continue.)","ref":"NSQ.Consumer.Backoff.html#resume/2","title":"NSQ.Consumer.Backoff.resume/2","type":"function"},{"doc":"","ref":"NSQ.Consumer.Backoff.html#resume!/2","title":"NSQ.Consumer.Backoff.resume!/2","type":"function"},{"doc":"Decision point about whether to continue/end/ignore backoff.","ref":"NSQ.Consumer.Backoff.html#start_stop_continue/3","title":"NSQ.Consumer.Backoff.start_stop_continue/3","type":"function"},{"doc":"","ref":"NSQ.Consumer.Backoff.html#start_stop_continue!/3","title":"NSQ.Consumer.Backoff.start_stop_continue!/3","type":"function"},{"doc":"Functions for connecting, disconnecting, managing connections, etc.","ref":"NSQ.Consumer.Connections.html","title":"NSQ.Consumer.Connections","type":"module"},{"doc":"When a connection is terminated or dies, we must do some extra cleanup.\nFirst, a terminated process isn't necessarily removed from the supervisor's\nlist; therefore we call `Supervisor.delete_child/2`. And info about this\nconnection like RDY must be removed so it doesn't contribute to `total_rdy`.\nNot for external use.","ref":"NSQ.Consumer.Connections.html#cleanup_connection/3","title":"NSQ.Consumer.Connections.cleanup_connection/3","type":"function"},{"doc":"","ref":"NSQ.Consumer.Connections.html#close/1","title":"NSQ.Consumer.Connections.close/1","type":"function"},{"doc":"","ref":"NSQ.Consumer.Connections.html#close!/1","title":"NSQ.Consumer.Connections.close!/1","type":"function"},{"doc":"Create a connection to NSQD and add it to the consumer's supervised list.\nNot for external use.","ref":"NSQ.Consumer.Connections.html#connect_to_nsqd/3","title":"NSQ.Consumer.Connections.connect_to_nsqd/3","type":"function"},{"doc":"Given a list of NSQD hosts, open a connection for each.","ref":"NSQ.Consumer.Connections.html#connect_to_nsqds/3","title":"NSQ.Consumer.Connections.connect_to_nsqds/3","type":"function"},{"doc":"","ref":"NSQ.Consumer.Connections.html#count/1","title":"NSQ.Consumer.Connections.count/1","type":"function"},{"doc":"We may have open connections which nsqlookupd stops reporting. This function\ntells us which connections we have stored in state but not in nsqlookupd.\nNot for external use.","ref":"NSQ.Consumer.Connections.html#dead_connections/3","title":"NSQ.Consumer.Connections.dead_connections/3","type":"function"},{"doc":"Iterate over all listed connections and delete the ones that are dead. This\nexists because it is difficult to reliably clean up a connection immediately\nafter it is terminated (it might still be running). This function runs in the\ndiscovery loop to provide consistency.","ref":"NSQ.Consumer.Connections.html#delete_dead/1","title":"NSQ.Consumer.Connections.delete_dead/1","type":"function"},{"doc":"","ref":"NSQ.Consumer.Connections.html#delete_dead!/1","title":"NSQ.Consumer.Connections.delete_dead!/1","type":"function"},{"doc":"Frequently, when testing, we publish a message then immediately want a\nconsumer to process it, but this doesn't work if the consumer doesn't\ndiscover the nsqd first. Only meant for testing.","ref":"NSQ.Consumer.Connections.html#discover_nsqds/1","title":"NSQ.Consumer.Connections.discover_nsqds/1","type":"function"},{"doc":"Finds and updates list of live NSQDs using either NSQ.Config.nsqlookupds or\nNSQ.Config.nsqds, depending on what's configured. Preference is given to\nnsqlookupd. Not for external use.","ref":"NSQ.Consumer.Connections.html#discover_nsqds_and_connect/2","title":"NSQ.Consumer.Connections.discover_nsqds_and_connect/2","type":"function"},{"doc":"Initialized from NSQ.Consumer.Supervisor, sends the consumer a message on a\nfixed interval.","ref":"NSQ.Consumer.Connections.html#discovery_loop/1","title":"NSQ.Consumer.Connections.discovery_loop/1","type":"function"},{"doc":"Returns all live connections for a consumer. This function, which takes\na consumer's entire state as an argument, is for convenience. Not for\nexternal use.","ref":"NSQ.Consumer.Connections.html#get/1","title":"NSQ.Consumer.Connections.get/1","type":"function"},{"doc":"Returns all live connections for a consumer. Used in tests. Not for external\nuse.","ref":"NSQ.Consumer.Connections.html#get/2","title":"NSQ.Consumer.Connections.get/2","type":"function"},{"doc":"","ref":"NSQ.Consumer.Connections.html#idle_with_rdy/1","title":"NSQ.Consumer.Connections.idle_with_rdy/1","type":"function"},{"doc":"When nsqlookupd reports available producers, there are some that may not\nalready be in our connection list. This function reports which ones are new\nso we can connect to them.","ref":"NSQ.Consumer.Connections.html#new_nsqds/3","title":"NSQ.Consumer.Connections.new_nsqds/3","type":"function"},{"doc":"","ref":"NSQ.Consumer.Connections.html#reconnect_failed/1","title":"NSQ.Consumer.Connections.reconnect_failed/1","type":"function"},{"doc":"","ref":"NSQ.Consumer.Connections.html#refresh/1","title":"NSQ.Consumer.Connections.refresh/1","type":"function"},{"doc":"","ref":"NSQ.Consumer.Connections.html#refresh!/1","title":"NSQ.Consumer.Connections.refresh!/1","type":"function"},{"doc":"Given a single connection, immediately terminate its process (and all\ndescendant processes, such as message handlers) and remove its info from the\nConnInfo agent. Not for external use.","ref":"NSQ.Consumer.Connections.html#stop_connection/3","title":"NSQ.Consumer.Connections.stop_connection/3","type":"function"},{"doc":"Given a list of connections, force them to stop. Return the new state without\nthose connections.","ref":"NSQ.Consumer.Connections.html#stop_connections/3","title":"NSQ.Consumer.Connections.stop_connections/3","type":"function"},{"doc":"Any inactive connections will be killed and any newly discovered connections\nwill be added. Existing connections with no change are left alone. Not for\nexternal use.","ref":"NSQ.Consumer.Connections.html#update/3","title":"NSQ.Consumer.Connections.update/3","type":"function"},{"doc":"","ref":"NSQ.Consumer.Helpers.html","title":"NSQ.Consumer.Helpers","type":"module"},{"doc":"","ref":"NSQ.Consumer.Helpers.html#conn_from_nsqd/3","title":"NSQ.Consumer.Helpers.conn_from_nsqd/3","type":"function"},{"doc":"","ref":"NSQ.Consumer.Helpers.html#now/0","title":"NSQ.Consumer.Helpers.now/0","type":"function"},{"doc":"Returns how much `max_in_flight` should be distributed to each connection.\nIf `max_in_flight` is less than the number of connections, then this always\nreturns 1 and they are randomly distributed via `redistribute_rdy`. Not for\nexternal use.","ref":"NSQ.Consumer.Helpers.html#per_conn_max_in_flight/1","title":"NSQ.Consumer.Helpers.per_conn_max_in_flight/1","type":"function"},{"doc":"Each connection is responsible for maintaining its own rdy_count in ConnInfo.\nThis function sums all the values of rdy_count for each connection, which\nlets us get an accurate picture of a consumer's total RDY count. Not for\nexternal use.","ref":"NSQ.Consumer.Helpers.html#total_rdy_count/1","title":"NSQ.Consumer.Helpers.total_rdy_count/1","type":"function"},{"doc":"Consumers have a lot of logic around calculating and distributing RDY. This\nis where that goes!","ref":"NSQ.Consumer.RDY.html","title":"NSQ.Consumer.RDY","type":"module"},{"doc":"If we're not in backoff mode and we've hit a \"trigger point\" to update RDY,\nthen go ahead and update RDY. Not for external use.","ref":"NSQ.Consumer.RDY.html#maybe_update/3","title":"NSQ.Consumer.RDY.maybe_update/3","type":"function"},{"doc":"","ref":"NSQ.Consumer.RDY.html#maybe_update!/3","title":"NSQ.Consumer.RDY.maybe_update!/3","type":"function"},{"doc":"This will only be triggered in odd cases where we're in backoff or when there\nare more connections than max in flight. It will randomly change RDY on\nsome connections to 0 and 1 so that they're all guaranteed to eventually\nprocess messages.","ref":"NSQ.Consumer.RDY.html#redistribute/2","title":"NSQ.Consumer.RDY.redistribute/2","type":"function"},{"doc":"","ref":"NSQ.Consumer.RDY.html#redistribute!/2","title":"NSQ.Consumer.RDY.redistribute!/2","type":"function"},{"doc":"Initialized from NSQ.Consumer.Supervisor, sends the consumer a message on a\nfixed interval.","ref":"NSQ.Consumer.RDY.html#redistribute_loop/1","title":"NSQ.Consumer.RDY.redistribute_loop/1","type":"function"},{"doc":"Delay for a configured interval, then call RDY.update.","ref":"NSQ.Consumer.RDY.html#retry/4","title":"NSQ.Consumer.RDY.retry/4","type":"function"},{"doc":"Send a RDY command for the given connection.","ref":"NSQ.Consumer.RDY.html#transmit/3","title":"NSQ.Consumer.RDY.transmit/3","type":"function"},{"doc":"Try to update RDY for a given connection, taking configuration and the\ncurrent state into account. Not for external use.","ref":"NSQ.Consumer.RDY.html#update/4","title":"NSQ.Consumer.RDY.update/4","type":"function"},{"doc":"","ref":"NSQ.Consumer.RDY.html#update!/4","title":"NSQ.Consumer.RDY.update!/4","type":"function"},{"doc":"","ref":"NSQ.Consumer.Supervisor.html","title":"NSQ.Consumer.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Consumer.Supervisor.html#child_spec/1","title":"NSQ.Consumer.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"NSQ.Consumer.Supervisor.html#start_link/4","title":"NSQ.Consumer.Supervisor.start_link/4","type":"function"},{"doc":"","ref":"NSQ.Logger.html","title":"NSQ.Logger","type":"module"},{"doc":"","ref":"NSQ.Logger.html#configure/1","title":"NSQ.Logger.configure/1","type":"function"},{"doc":"","ref":"NSQ.Logger.html#debug/1","title":"NSQ.Logger.debug/1","type":"function"},{"doc":"","ref":"NSQ.Logger.html#error/1","title":"NSQ.Logger.error/1","type":"function"},{"doc":"","ref":"NSQ.Logger.html#info/1","title":"NSQ.Logger.info/1","type":"function"},{"doc":"","ref":"NSQ.Logger.html#warn/1","title":"NSQ.Logger.warn/1","type":"function"},{"doc":"","ref":"NSQ.Lookupd.html","title":"NSQ.Lookupd","type":"module"},{"doc":"","ref":"NSQ.Lookupd.html#nsqds_with_topic/2","title":"NSQ.Lookupd.nsqds_with_topic/2","type":"function"},{"doc":"","ref":"NSQ.Lookupd.html#topics_from_lookupd/2","title":"NSQ.Lookupd.topics_from_lookupd/2","type":"function"},{"doc":"All lookupd responses should return a map with these values. If the response\nis not of that form, it should be normalized into that form.","ref":"NSQ.Lookupd.html#t:response/0","title":"NSQ.Lookupd.response/0","type":"type"},{"doc":"","ref":"NSQ.Message.html","title":"NSQ.Message","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Message.html#child_spec/1","title":"NSQ.Message.child_spec/1","type":"function"},{"doc":"Tells NSQD that we're done processing this message. This is called\nautomatically when the handler returns successfully, or when all retries have\nbeen exhausted.","ref":"NSQ.Message.html#fin/1","title":"NSQ.Message.fin/1","type":"function"},{"doc":"Given a raw NSQ message with frame_type = message, return a struct with its\nparsed data.","ref":"NSQ.Message.html#from_data/1","title":"NSQ.Message.from_data/1","type":"function"},{"doc":"","ref":"NSQ.Message.html#init/1","title":"NSQ.Message.init/1","type":"function"},{"doc":"This is the main entry point when processing a message. It starts the message\nGenServer and immediately kicks of a processing call.","ref":"NSQ.Message.html#process/1","title":"NSQ.Message.process/1","type":"function"},{"doc":"Tells NSQD to requeue the message, with delay and backoff. According to the\ngo-nsq client (but doc'ed nowhere), a delay of -1 is a special value that\nmeans nsqd will calculate the duration itself based on the default requeue\ntimeout. If backoff=true is set, then the connection will go into \"backoff\"\nmode, where it stops receiving messages for a fixed duration.","ref":"NSQ.Message.html#req/3","title":"NSQ.Message.req/3","type":"function"},{"doc":"","ref":"NSQ.Message.html#start_link/2","title":"NSQ.Message.start_link/2","type":"function"},{"doc":"This function is intended to be used by the handler for long-running\nfunctions. They can set up a separate process that periodically touches the\nmessage until the process finishes.","ref":"NSQ.Message.html#touch/1","title":"NSQ.Message.touch/1","type":"function"},{"doc":"","ref":"NSQ.Message.Supervisor.html","title":"NSQ.Message.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Message.Supervisor.html#child_spec/1","title":"NSQ.Message.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"NSQ.Message.Supervisor.html#start_child/3","title":"NSQ.Message.Supervisor.start_child/3","type":"function"},{"doc":"","ref":"NSQ.Message.Supervisor.html#start_link/1","title":"NSQ.Message.Supervisor.start_link/1","type":"function"},{"doc":"A producer is a process that connects to one or many NSQDs and publishes\nmessages.","ref":"NSQ.Producer.html","title":"NSQ.Producer","type":"module"},{"doc":"To initialize:\n\n    {:ok, producer} = NSQ.Producer.Supervisor.start_link(\"the-default-topic\", %NSQ.Config{\n      nsqds: [\"127.0.0.1:6750\"]\n    })\n\nThe default `topic` argument is _required_, even if you plan on explicitly\npublishing to a different topic. If you don't plan on using, you can set it\nto something like `_default_topic_`.\n\nIf you provide more than one nsqd, each `pub`/`mpub` will choose one\nrandomly.\n\nNote that, unlike consumers, producers _cannot_ be configured to use\ndiscovery with nsqlookupd. This is because discovery requires a topic and\nchannel, and an nsqd will only appear in nsqlookupd if it has already\npublished messages on that topic. So there's a chicken-and-egg problem. The\nrecommended solution is to run NSQD on the same box where you're publishing,\nso your address is always 127.0.0.1 with a static port.\n\n#","ref":"NSQ.Producer.html#module-interface","title":"Interface - NSQ.Producer","type":"module"},{"doc":"Publish a single message to NSQD.\n\n    NSQ.Producer.pub(producer, \"a message\")\n    NSQ.Producer.pub(producer, \"different-topic\", \"a message\")\n\n#","ref":"NSQ.Producer.html#module-pub","title":"pub - NSQ.Producer","type":"module"},{"doc":"Publish a bunch of messages to NSQD atomically.\n\n    NSQ.Producer.mpub(producer, [\"one\", \"two\"])\n    NSQ.Producer.mpub(producer, \"different-topic\", [\"one\", \"two\"])","ref":"NSQ.Producer.html#module-mpub","title":"mpub - NSQ.Producer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Producer.html#child_spec/1","title":"NSQ.Producer.child_spec/1","type":"function"},{"doc":"Create supervised connections to NSQD.","ref":"NSQ.Producer.html#connect_to_nsqds/3","title":"NSQ.Producer.connect_to_nsqds/3","type":"function"},{"doc":"The end-user will be targeting the supervisor, but it's the producer that\ncan actually handle the command.","ref":"NSQ.Producer.html#get/1","title":"NSQ.Producer.get/1","type":"function"},{"doc":"","ref":"NSQ.Producer.html#get_connections/1","title":"NSQ.Producer.get_connections/1","type":"function"},{"doc":"","ref":"NSQ.Producer.html#get_connections/2","title":"NSQ.Producer.get_connections/2","type":"function"},{"doc":"Get the current state of a producer. Used in tests. Not for external use.","ref":"NSQ.Producer.html#get_state/1","title":"NSQ.Producer.get_state/1","type":"function"},{"doc":"","ref":"NSQ.Producer.html#init/1","title":"NSQ.Producer.init/1","type":"function"},{"doc":"Publish data to whatever topic is the default.","ref":"NSQ.Producer.html#mpub/2","title":"NSQ.Producer.mpub/2","type":"function"},{"doc":"Publish data to a specific topic.","ref":"NSQ.Producer.html#mpub/3","title":"NSQ.Producer.mpub/3","type":"function"},{"doc":"Publish data to whatever topic is the default.","ref":"NSQ.Producer.html#pub/2","title":"NSQ.Producer.pub/2","type":"function"},{"doc":"Publish data to a specific topic.","ref":"NSQ.Producer.html#pub/3","title":"NSQ.Producer.pub/3","type":"function"},{"doc":"","ref":"NSQ.Producer.html#random_connection_pid/1","title":"NSQ.Producer.random_connection_pid/1","type":"function"},{"doc":"","ref":"NSQ.Producer.html#start_link/1","title":"NSQ.Producer.start_link/1","type":"function"},{"doc":"A tuple with a string ID (used to target the connection in\nNSQ.Connection.Supervisor) and a PID of the connection.","ref":"NSQ.Producer.html#t:connection/0","title":"NSQ.Producer.connection/0","type":"type"},{"doc":"A tuple with a host and a port.","ref":"NSQ.Producer.html#t:host_with_port/0","title":"NSQ.Producer.host_with_port/0","type":"type"},{"doc":"A map, but we can be more specific by asserting some entries that should be\nset for a connection's state map.","ref":"NSQ.Producer.html#t:pro_state/0","title":"NSQ.Producer.pro_state/0","type":"type"},{"doc":"","ref":"NSQ.Producer.Supervisor.html","title":"NSQ.Producer.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NSQ.Producer.Supervisor.html#child_spec/1","title":"NSQ.Producer.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"NSQ.Producer.Supervisor.html#start_link/3","title":"NSQ.Producer.Supervisor.start_link/3","type":"function"},{"doc":"","ref":"NSQ.Protocol.html","title":"NSQ.Protocol","type":"module"},{"doc":"","ref":"NSQ.Protocol.html#decode/1","title":"NSQ.Protocol.decode/1","type":"function"},{"doc":"","ref":"NSQ.Protocol.html#decode_as_message/1","title":"NSQ.Protocol.decode_as_message/1","type":"function"},{"doc":"Refer to http://nsq.io/clients/tcp_protocol_spec.html.","ref":"NSQ.Protocol.html#encode/1","title":"NSQ.Protocol.encode/1","type":"function"},{"doc":"","ref":"NSQ.Protocol.html#is_valid_channel_name?/1","title":"NSQ.Protocol.is_valid_channel_name?/1","type":"function"},{"doc":"","ref":"NSQ.Protocol.html#is_valid_topic_name?/1","title":"NSQ.Protocol.is_valid_topic_name?/1","type":"function"},{"doc":"","ref":"NSQ.Protocol.html#ok_msg/0","title":"NSQ.Protocol.ok_msg/0","type":"function"},{"doc":"","ref":"NSQ.Protocol.html#response_msg/1","title":"NSQ.Protocol.response_msg/1","type":"function"}]}